# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.BuiltInSimpleActionAdditionalContent do
  @moduledoc """
  Long text from external source.

  ## Attributes

  *   `paragraphs` (*type:* `list(String.t)`, *default:* `nil`) - Long text organized into paragraphs.
  *   `title` (*type:* `String.t`, *default:* `nil`) - Title of the additional content;
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :paragraphs => list(String.t()) | nil,
          :title => String.t() | nil
        }

  field(:paragraphs, type: :list)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.BuiltInSimpleActionAdditionalContent do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.BuiltInSimpleActionAdditionalContent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.BuiltInSimpleActionAdditionalContent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
