# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ConversionSource do
  @moduledoc """
  Represents a conversion source owned by a Merchant account. A merchant account can have up to 200 conversion sources.

  ## Attributes

  *   `conversionSourceId` (*type:* `String.t`, *default:* `nil`) - Output only. Generated by the Content API upon creation of a new `ConversionSource`. Format: [a-z]{4}:.+ The four characters before the colon represent the type of conversio source. Content after the colon represents the ID of the conversion source within that type. The ID of two different conversion sources might be the same across different types. The following type prefixes are supported: - galk: For GoogleAnalyticsLink sources. - mcdn: For MerchantCenterDestination sources.
  *   `expireTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time when an archived conversion source becomes permanently deleted and is no longer available to undelete.
  *   `googleAnalyticsLink` (*type:* `GoogleApi.Content.V21.Model.GoogleAnalyticsLink.t`, *default:* `nil`) - Immutable. Conversion Source of type "Link to Google Analytics Property".
  *   `merchantCenterDestination` (*type:* `GoogleApi.Content.V21.Model.MerchantCenterDestination.t`, *default:* `nil`) - Conversion Source of type "Merchant Center Tag Destination".
  *   `state` (*type:* `String.t`, *default:* `nil`) - Output only. Current state of this conversion source. Can't be edited through the API.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :conversionSourceId => String.t() | nil,
          :expireTime => DateTime.t() | nil,
          :googleAnalyticsLink => GoogleApi.Content.V21.Model.GoogleAnalyticsLink.t() | nil,
          :merchantCenterDestination =>
            GoogleApi.Content.V21.Model.MerchantCenterDestination.t() | nil,
          :state => String.t() | nil
        }

  field(:conversionSourceId)
  field(:expireTime, as: DateTime)
  field(:googleAnalyticsLink, as: GoogleApi.Content.V21.Model.GoogleAnalyticsLink)
  field(:merchantCenterDestination, as: GoogleApi.Content.V21.Model.MerchantCenterDestination)
  field(:state)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ConversionSource do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ConversionSource.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ConversionSource do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
