# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ExternalAction do
  @moduledoc """
  Action that is implemented and performed outside of the third-party application. It should redirect the merchant to the provided URL of an external system where they can perform the action. For example to request a review in the Merchant Center.

  ## Attributes

  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of external action.
  *   `uri` (*type:* `String.t`, *default:* `nil`) - URL to external system, for example Merchant Center, where the merchant can perform the action.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :type => String.t() | nil,
          :uri => String.t() | nil
        }

  field(:type)
  field(:uri)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ExternalAction do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ExternalAction.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ExternalAction do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
