# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ListConversionSourcesResponse do
  @moduledoc """
  Response message for the ListConversionSources method.

  ## Attributes

  *   `conversionSources` (*type:* `list(GoogleApi.Content.V21.Model.ConversionSource.t)`, *default:* `nil`) - List of conversion sources.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token to be used to fetch the next results page.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :conversionSources => list(GoogleApi.Content.V21.Model.ConversionSource.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:conversionSources, as: GoogleApi.Content.V21.Model.ConversionSource, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ListConversionSourcesResponse do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ListConversionSourcesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ListConversionSourcesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
