# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ProductDeliveryTimeAreaDeliveryTimeDeliveryTime do
  @moduledoc """
  A delivery time for this product.

  ## Attributes

  *   `maxHandlingTimeDays` (*type:* `integer()`, *default:* `nil`) - Required. The maximum number of business days (inclusive) between when an order is placed and when the product ships. If a product ships in the same day, set this value to 0.
  *   `maxTransitTimeDays` (*type:* `integer()`, *default:* `nil`) - Required. The maximum number of business days (inclusive) between when the product ships and when the product is delivered.
  *   `minHandlingTimeDays` (*type:* `integer()`, *default:* `nil`) - Required. The minimum number of business days (inclusive) between when an order is placed and when the product ships. If a product ships in the same day, set this value to 0.
  *   `minTransitTimeDays` (*type:* `integer()`, *default:* `nil`) - Required. The minimum number of business days (inclusive) between when the product ships and when the product is delivered.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :maxHandlingTimeDays => integer() | nil,
          :maxTransitTimeDays => integer() | nil,
          :minHandlingTimeDays => integer() | nil,
          :minTransitTimeDays => integer() | nil
        }

  field(:maxHandlingTimeDays)
  field(:maxTransitTimeDays)
  field(:minHandlingTimeDays)
  field(:minTransitTimeDays)
end

defimpl Poison.Decoder,
  for: GoogleApi.Content.V21.Model.ProductDeliveryTimeAreaDeliveryTimeDeliveryTime do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ProductDeliveryTimeAreaDeliveryTimeDeliveryTime.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Content.V21.Model.ProductDeliveryTimeAreaDeliveryTimeDeliveryTime do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
