# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ProductViewItemIssueIssueSeverityPerDestination do
  @moduledoc """
  Issue severity for all affected regions in a destination.

  ## Attributes

  *   `demotedCountries` (*type:* `list(String.t)`, *default:* `nil`) - List of demoted countries in the destination.
  *   `destination` (*type:* `String.t`, *default:* `nil`) - Issue destination.
  *   `disapprovedCountries` (*type:* `list(String.t)`, *default:* `nil`) - List of disapproved countries in the destination.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :demotedCountries => list(String.t()) | nil,
          :destination => String.t() | nil,
          :disapprovedCountries => list(String.t()) | nil
        }

  field(:demotedCountries, type: :list)
  field(:destination)
  field(:disapprovedCountries, type: :list)
end

defimpl Poison.Decoder,
  for: GoogleApi.Content.V21.Model.ProductViewItemIssueIssueSeverityPerDestination do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ProductViewItemIssueIssueSeverityPerDestination.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Content.V21.Model.ProductViewItemIssueIssueSeverityPerDestination do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
