# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ProductViewItemIssueItemIssueSeverity do
  @moduledoc """
  Severity of an issue per destination in a region, and aggregated severity.

  ## Attributes

  *   `aggregatedSeverity` (*type:* `String.t`, *default:* `nil`) - Severity of an issue aggregated for destination.
  *   `severityPerDestination` (*type:* `list(GoogleApi.Content.V21.Model.ProductViewItemIssueIssueSeverityPerDestination.t)`, *default:* `nil`) - Item issue severity for every destination.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :aggregatedSeverity => String.t() | nil,
          :severityPerDestination =>
            list(GoogleApi.Content.V21.Model.ProductViewItemIssueIssueSeverityPerDestination.t())
            | nil
        }

  field(:aggregatedSeverity)

  field(:severityPerDestination,
    as: GoogleApi.Content.V21.Model.ProductViewItemIssueIssueSeverityPerDestination,
    type: :list
  )
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ProductViewItemIssueItemIssueSeverity do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ProductViewItemIssueItemIssueSeverity.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ProductViewItemIssueItemIssueSeverity do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
