# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Content.V21.Model.ReportRow do
  @moduledoc """
  Result row returned from the search query.

  ## Attributes

  *   `bestSellers` (*type:* `GoogleApi.Content.V21.Model.BestSellers.t`, *default:* `nil`) - Best sellers fields requested by the merchant in the query. Field values are only set if the merchant queries `BestSellersProductClusterView` or `BestSellersBrandView`.
  *   `brand` (*type:* `GoogleApi.Content.V21.Model.Brand.t`, *default:* `nil`) - Brand fields requested by the merchant in the query. Field values are only set if the merchant queries `BestSellersBrandView`.
  *   `competitiveVisibility` (*type:* `GoogleApi.Content.V21.Model.CompetitiveVisibility.t`, *default:* `nil`) - Competitive visibility fields requested by the merchant in the query. Field values are only set if the merchant queries `CompetitiveVisibilityTopMerchantView`, `CompetitiveVisibilityBenchmarkView` or `CompetitiveVisibilityCompetitorView`.
  *   `metrics` (*type:* `GoogleApi.Content.V21.Model.Metrics.t`, *default:* `nil`) - Metrics requested by the merchant in the query. Metric values are only set for metrics requested explicitly in the query.
  *   `priceCompetitiveness` (*type:* `GoogleApi.Content.V21.Model.PriceCompetitiveness.t`, *default:* `nil`) - Price competitiveness fields requested by the merchant in the query. Field values are only set if the merchant queries `PriceCompetitivenessProductView`.
  *   `priceInsights` (*type:* `GoogleApi.Content.V21.Model.PriceInsights.t`, *default:* `nil`) - Price insights fields requested by the merchant in the query. Field values are only set if the merchant queries `PriceInsightsProductView`.
  *   `productCluster` (*type:* `GoogleApi.Content.V21.Model.ProductCluster.t`, *default:* `nil`) - Product cluster fields requested by the merchant in the query. Field values are only set if the merchant queries `BestSellersProductClusterView`.
  *   `productView` (*type:* `GoogleApi.Content.V21.Model.ProductView.t`, *default:* `nil`) - Product fields requested by the merchant in the query. Field values are only set if the merchant queries `ProductView`.
  *   `segments` (*type:* `GoogleApi.Content.V21.Model.Segments.t`, *default:* `nil`) - Segmentation dimensions requested by the merchant in the query. Dimension values are only set for dimensions requested explicitly in the query.
  *   `topicTrends` (*type:* `GoogleApi.Content.V21.Model.TopicTrends.t`, *default:* `nil`) - [Topic trends](https://support.google.com/merchants/answer/13542370) fields requested by the merchant in the query. Field values are only set if the merchant queries `TopicTrendsView`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :bestSellers => GoogleApi.Content.V21.Model.BestSellers.t() | nil,
          :brand => GoogleApi.Content.V21.Model.Brand.t() | nil,
          :competitiveVisibility => GoogleApi.Content.V21.Model.CompetitiveVisibility.t() | nil,
          :metrics => GoogleApi.Content.V21.Model.Metrics.t() | nil,
          :priceCompetitiveness => GoogleApi.Content.V21.Model.PriceCompetitiveness.t() | nil,
          :priceInsights => GoogleApi.Content.V21.Model.PriceInsights.t() | nil,
          :productCluster => GoogleApi.Content.V21.Model.ProductCluster.t() | nil,
          :productView => GoogleApi.Content.V21.Model.ProductView.t() | nil,
          :segments => GoogleApi.Content.V21.Model.Segments.t() | nil,
          :topicTrends => GoogleApi.Content.V21.Model.TopicTrends.t() | nil
        }

  field(:bestSellers, as: GoogleApi.Content.V21.Model.BestSellers)
  field(:brand, as: GoogleApi.Content.V21.Model.Brand)
  field(:competitiveVisibility, as: GoogleApi.Content.V21.Model.CompetitiveVisibility)
  field(:metrics, as: GoogleApi.Content.V21.Model.Metrics)
  field(:priceCompetitiveness, as: GoogleApi.Content.V21.Model.PriceCompetitiveness)
  field(:priceInsights, as: GoogleApi.Content.V21.Model.PriceInsights)
  field(:productCluster, as: GoogleApi.Content.V21.Model.ProductCluster)
  field(:productView, as: GoogleApi.Content.V21.Model.ProductView)
  field(:segments, as: GoogleApi.Content.V21.Model.Segments)
  field(:topicTrends, as: GoogleApi.Content.V21.Model.TopicTrends)
end

defimpl Poison.Decoder, for: GoogleApi.Content.V21.Model.ReportRow do
  def decode(value, options) do
    GoogleApi.Content.V21.Model.ReportRow.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Content.V21.Model.ReportRow do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
